%include "dos.h"
%include "cstr.h"

%define MF_NoCursorRoutines

segment code
..start:
	mov ax,data ;begin segment setup
	mov ds,ax
	mov ax,stack
	mov ss,ax
	mov sp,stacktop ;end segment setup

	push ds		;get video segment location
	mov ax,0x40
	mov ds,ax
	mov ax,[0xe0]
	pop ds
	mov [vidseg],ax

	call CountFiles
	mov [numfiles],cx

	;mov [ss:bx+stacktop],word 0x7777
	
FileMenu:
	mov ax,[vidseg]
	mov es,ax


	call MF_ClearScreen

	mov [MF_CursorRow],byte 0
	mov si,titlestring
	call MF_CenterForString
	call MF_DisplayString

	mov [MF_CursorRow],byte 12
	cmp word [numfiles],0x0000
	jne .HaveFiles

	mov si,nofiles
	call MF_CenterForString
	call MF_DisplayString

	jmp short .Continue
.HaveFiles
	mov [MF_CursorCol],byte 8
	mov si,filenummsg
	call MF_DisplayString
	mov ax,[selfile]
	call MF_DisplayNumAX
	mov al,"/"
	call MF_DisplayChar
	mov ax,[numfiles]
	call MF_DisplayNumAX

	mov [MF_CursorLocation],word 0x1208
	mov si,filenamemsg
	call MF_DisplayString
	mov cx,[selfile]
	push es
	call FindFileStart
	push word [es:si]
	add si,3
	mov cx,8
.DispNameLp
	cld
	es lodsb
	push si
	push cx
	push es
	push word [vidseg]
	pop es
	call MF_DisplayChar
	pop es
	pop cx
	pop si
	loop .DispNameLp
	pop ax
	mov [MF_CursorLocation],word 0x1808
	mov si,filesizemsg
	pop es
	call MF_DisplayString
	sub ax,24
	call MF_DisplayNumAX

.Continue

	mov [MF_CursorRow],byte 48
	mov si,instruction
	call MF_CenterForString
	call MF_DisplayString

	mov [MF_CursorRow],byte 54
	mov si,copystring
	call MF_CenterForString
	call MF_DisplayString


	;main menu keyboard code

.GetKey	m_DosReadKeyboard
	m_BranchIf al,ne,0,short .GetKey	
	m_DosReadKeyboard
	cmp al,59
	jne .Test80
	call ProgramInfo
	jmp FileMenu
.Test80	cmp al,80
	jne .Test72
	mov ax,[selfile]
	inc ax
	cmp ax,[numfiles]
	jbe .NoSetOne
	mov ax,0x0001
.NoSetOne
	mov [selfile],ax
	jmp FileMenu
.Test72	cmp al,72
	jne .Test28
	mov ax,[selfile]
	dec ax
	jnz .NoSetMax
	mov ax,[numfiles]
.NoSetMax
	mov [selfile],ax
	jmp FileMenu
.Test28	cmp al,28
	jne .Test1
	cmp word [numfiles],byte 0x00
	je .GetKey
	mov cx,[selfile]
	call FindFileStart
	mov ax,[es:si]
	sub ax,24
	mov [filesize],ax
	add si,21
	mov bp,si
	xor si,si
	push es
	pop word [fileseg]
	call DisplayFile
	push word [vidseg]
	pop es
	jmp FileMenu
.Test1	cmp al,1
	jne .GetKey
	m_DosTerminateProcess 0x00


DisplayFile:
	call IndexFile
        mov [curline],word 0x0001

.DispLp	call DisplayScreen
.KeyLp	m_DosReadKeyboard
	cmp al,0
	jne .KeyLp
	int 0x21 ;read kbd

	cmp al,72	;up
	jne .not72
        dec word [curline]
	jnz .DispLp
	mov word [curline],1
	jmp short .KeyLp

.not72	cmp al,80	;down
	jne .not80
	mov ax,[curline]
	inc ax
	cmp ax,[filelines]
	mov [curline],ax
	jna .DispLp
	dec word [curline]
	jmp short .KeyLp

.not80	cmp al,1	;esc
	jne .not1
	ret
.not1	cmp al,75	;left (page up)
	jne .not75
	mov ax,[curline]
	sub ax,9
	mov [curline],ax
	ja .DispLp
	mov [curline],word 1
	jmp short .DispLp

.not75	cmp al,77	;right (page down)
	jne .KeyLp ;.not77
	mov ax,[curline]
	add ax,9
	mov [curline],ax
	cmp ax,[filelines]
	jbe .DispLp
	sub word [curline],byte 9
	jmp short .DispLp
.not77
	;jmp short .KeyLp



DisplayScreen:
	;displays the current screen of text, according to [curline]
	;trashed:
	;flags, various

	push cx
	push es
	mov cx,[vidseg]
	add cx,0x40
	mov es,cx
	call MF_ClearScreen	;clear second page
	pop es

	mov cx,[curline]
	dec cx
	mov bx,cx

	and bx,0xfff0
	shr bx,3
	mov si,[ss:bx+stacktop]
	
	and cx,0x000f
        jz .NoSkip

.SkipLp
	mov bx,cx
	call FindLineLength
	mov cx,bx
	loop .SkipLp

.NoSkip
	mov [MF_CursorLocation],word 0x0000
	mov cx,10 ;display 10 lines

	mov word [MF_CursorLocation],0

.DispLp 
	call DisplayLine
	add byte [MF_CursorRow],byte 0x06
	mov [MF_CursorCol],byte 0x00
	loop .DispLp	

	;now copy the 2nd page to the 1st, and voila!
	push si
	push di
	push ds
	push es
	mov cx,[vidseg]
	mov es,cx
	add cx,0x40
	mov ds,cx
        xor si,si
        xor di,di
	cld
	mov cx,0x200
	rep movsw
	pop es
	pop ds
	pop di
	pop si

	pop cx
	ret


IndexFile:
	;on entry: es:bp = file location
	;          [filesize] = file size
	;return:
	;[filelines]
	;index table
	;trashed:
	;figure it out, genius :)

	push es
	mov ax,[vidseg]
	mov es,ax
	call MF_ClearScreen
	mov si,indexmsg
	call MF_DisplayString

	;mov ax,[filesize]
	;call MF_DisplayNumAX

	pop es

	xor si,si	;file pos
	xor dx,dx	;line num

	;mov [ss:stacktop],word 0x0000

.rowloop
	cmp [filesize],si
	jbe .exit	;FIXED

	;write the byte pos to index table if line mod 16=0
	mov bx,dx
	test bx,0x000f
	jnz .noindex
	and bx,0xfff0
	shr bx,3
	mov [ss:bx+stacktop],si

.noindex
	;m_DosTerminateProcess 0x00

	inc dx
	;now we call FindLineLength to skip to the next line
	call FindLineLength
	;push es
	;mov ax,[vidseg]
	;mov es,ax
	;push si
	;mov si,crmsg
	;call MF_DisplayString
	;mov ax,cx
	;call MF_DisplayNumAX
	;mov si,crmsg
	;call MF_DisplayString
	;pop si
	;mov ax,si
	;call MF_DisplayNumAX
	;push si
	;mov si,crmsg
	;call MF_DisplayString
	;pop si
	;pop es
	;m_DosReadKeyboard

	jmp short .rowloop
.exit
	mov [filelines],dx

	;push es
	;mov ax,[vidseg]
	;mov es,ax
	;mov si,okmsg
	;call MF_DisplayString
	;pop es
	ret

DisplayLine:
	;displays a line of text in the viewer (to 2nd page!)
	;on entry:
	;es:si+bp = first character of line
	;[filesize] = file size (duh)
	;on return:
	;es:si+bp = first character of next line (if possible)
	;destroyed:
	;ax, bx, dx, flags

	push cx
	push di

	mov di,si
	call FindLineLength
	push si
	mov si,di	

	or cx,cx
	jz .NoDisp

.DispLP mov al,[ES:BP+SI]
	inc si

	push cx
	push si
	push es
	mov bx,[vidseg]
	add bx,0x40	;display to 2nd page
	mov es,bx
	call MF_DisplayChar
	pop es
	pop si
	pop cx

	loop .DispLP
.NoDisp

	pop si

	pop di
	pop cx
	ret

FindLineLength:
	;on entry:
	;ES:BP+SI = starting character position
	;[DS:filesize] = file length
	;on return:
	;CX=line length
	;SI=recommended offset of next line
	;   (will NOT be old SI+CX in most cases)
	;trashed: flags
	push ax
	push bx
	push dx
	push di
	xor cx,cx
	xor bx,bx
	xor di,di
	mov dx,128 ;128=#columns

.MainLP
	cmp si,[filesize]
	jae .Exit ;end of file reached  ;FIXED
	mov al,[ES:BP+SI]
	inc si
	cmp al,13 ;CR
	je .Exit ;start at next char after CR (CR/LF
		 ;works fine, because LF is ignored)

	cmp al,32 ;space
	jne .NotSpace
	mov di,si
	mov bx,cx
.NotSpace
	inc cx
	push bx
	call MF_GetCharData
	pop bx
	and ax,0x0007
	sub dx,ax
	jnc .MainLP

	;at this point, BX is the number of characters before
	;	the last space encountered
	;DI is the offset of the byte after the last space
	;and... we have to use wordwrap.

	or bx,bx
	jnz .WordWrapScan
	;if we're executing this, then we have a line without spaces
	dec si
	dec cx	;don't display the character that wouldn't fit
	jmp short .Exit

.WordWrapScan
	mov cx,bx
	mov si,di
.ScanLp	cmp si,[filesize]
	jae .Exit		;FIXED
	mov al,[ES:BP+SI]
	cmp al,13
	je .IncExit
	cmp al,32
	jne .Exit
	inc si
	jmp short .ScanLp
.IncExit
	inc si
.Exit
	pop di
	pop dx
	pop bx
	pop ax
	ret


ProgramInfo:
	mov ax,[vidseg]
	mov es,ax
	call MF_ClearScreen
	mov si,versionstring
	call MF_CenterForString
	call MF_DisplayString
	mov si,copyinfo
	call MF_DisplayString
.GetKey	m_DosReadKeyboard
	or al,al
	jz .GetKey
	ret


AdjustAddressLow:
	;note - ES:SI used
	push ax
	push dx
	mov ax,si
	shr ax,4
	mov dx,es
	add ax,dx
	mov es,ax
	and si,0x000f
	pop dx
	pop ax
	ret

FindFileStart:
	;carry set on error
	;returned in ES:SI
	push ax
	push dx
	push cx
	xor si,si
	mov dx,0x200a
	mov ax,[vidseg]
	mov es,ax
.lp	add si,dx
	call AdjustAddressLow
	mov dx,[es:si]
	or dx,dx
	jz .error
	cmp byte [es:si+2],0x01
	jne .lp
	dec cx
	jnz .lp
	clc
.errex	pop cx
	pop dx
	pop ax
	ret
.error	stc
	jmp short .errex


CountFiles:
	push ax
	push dx
	push es
	push si
	xor cx,cx
	xor si,si
	mov dx,0x200a
	mov ax,[vidseg]
	mov es,ax
.lp	add si,dx
	call AdjustAddressLow
	mov dx,[es:si]
	or dx,dx
	jz .exit
	cmp byte [es:si+2],0x01
	jne .lp
	inc cx
	jmp short .lp
.exit	pop si
	pop es
	pop dx
	pop ax
	ret



%include "minifont.asm"


segment data

titlestring:
	db "CALIPSO TEXTREADER - SELECT FILE:",0
nofiles:
	db "NO CASIO BASIC FILES FOUND!",0
filenummsg:
	db "SELECTED FILE NUMBER: ",0
filenamemsg:
	db "FILE NAME: ",0
filesizemsg:
	db "FILE SIZE: ",0
instruction:
	db "UP/DOWN/EXE SELECT, ESC QUITS",0
copystring:
	db "F1: PROGRAM & COPYRIGHT INFO",0
versionstring:
	db "CALIPSO TEXTREADER V1.00",10,0
copyinfo:
	db "THIS PROGRAM IS COPYRIGHT",10
	db "(C)2001 BY THE CALIPSO TEAM.",10
	db 10
	db "PROGRAMMED BY:",10
	db " BRAD NORMAND - BRADN2@YAHOO.COM",10
	db 10
	db "CASIO ELITE - HTTP://CCP.S5.COM/",10
	db 10
	db "PRESS ANY KEY TO CONTINUE",0
indexmsg:
	db "WAIT...",0
okmsg:
	;db "OK",0
crmsg:
	;db 10,0
vidseg:	dw 0x0000
fileseg:
	dw 0x0000
numfiles:
	dw 0x0000
selfile:
	dw 0x0001
filesize:
	dw 0x0000
filepos:
	dw 0x0000
filelines:
	dw 0x0000
curline:
	dw 0x0000


segment stack stack ;this is our stack segment
	resb 0x0200
stacktop:
	resw 0x1000 ;index table space
